#include <bits/stdc++.h>

using namespace std;

int a[200010];
int b[200010];
int seg[400020];
int indddd;

int vre(int l, int d, int sl, int sd, int ind){
    if(l>sd || d<sl) return 0;
    if(l<=sl && d>=sd) return seg[ind];
    return vre(l,d,sl,(sl+sd)/2,2*ind+1)+vre(l,d,(sl+sd)/2+1,sd,2*ind+2);
}

int nel(int l, int d, int sl, int sd, int ind){
    if(sl==sd && seg[sl]==1){
        indddd=sl; return 1;
    }
    if(sl==sd) return 0;
    if(l>sd || d<sl) return 0;
    if(l<=sl && d>=sd){
        if(seg[ind]==1){
            nel(l,d,sl,(sl+sd)/2,2*ind+1);
            nel(l,d,(sl+sd)/2+1,sd,2*ind+2);
        }
        return seg[ind];
    }
    return nel(l,d,sl,(sl+sd)/2,2*ind+1)+nel(l,d,(sl+sd)/2+1,sd,2*ind+2);
}

void nap(int l, int d, int ind){
    if(l==d){
        seg[ind]=b[l];
        return;
    }
    if(l+1==d){
        seg[ind]=b[l]+b[d];
        return;
    }
    nap(l,(l+d)/2,2*ind+1);
    nap((l+d)/2+1,d,2*ind+2);
    seg[ind]=seg[2*ind+1]+seg[2*ind+2];
    return;
}

int main(){
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n; cin>>n;
    for(int i=0;i<n;i++) cin>>a[i];
    for(int i=1;i<n;i++) if(a[i]<a[i-1]) b[i]=1;
    nap(0,n-1,0);
    int q; cin>>q;
    for(int i=0;i<q;i++){
        int l,d; cin>>l>>d;
        l--;d--;
        int vre2=vre(l,d,0,n-1,0);
        if(vre2==0) cout<<"DA\n";
        else if(vre2==1||(vre2==2&&b[l]==1)){
            nel(l,d,0,n-1,0);
            if(indddd==1||indddd==l+1||indddd==l||(a[indddd-2]<=a[indddd])||indddd==n-1||indddd==d||(a[indddd-1]<=a[indddd+1])) cout<<"DA\n";
            else cout<<"NE\n";
        }
        else cout<<"NE\n";
    }
    return 0;
}